> ## Documentation Index
> Fetch the complete documentation index at: https://launchdarkly-preview.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Review approval request

> > For the complete documentation index, see [llms.txt](https://launchdarkly-preview.mintlify.app/llms.txt). For the full documentation snapshot, see [llms-full.txt](https://launchdarkly-preview.mintlify.app/llms-full.txt).

Review an approval request by approving or denying changes.



## OpenAPI

````yaml /openapi/launchdarkly-api.json post /api/v2/approval-requests/{id}/reviews
openapi: 3.0.3
info:
  title: LaunchDarkly REST API
  description: >
    > For the complete documentation index, see
    https://launchdarkly-preview.mintlify.app/llms.txt.

    > For the full documentation snapshot, see
    https://launchdarkly-preview.mintlify.app/llms-full.txt.


    This is the LaunchDarkly REST API. It lets you build custom integrations,
    automate your workflow, and manage feature flags and other LaunchDarkly
    resources programmatically.


    For authentication, rate limits, pagination, versioning, JSON Patch and
    semantic patches, beta resources, and the full SDK End-of-Life table, read
    the [REST API overview](https://launchdarkly-preview.mintlify.app/api).


    To fetch the complete OpenAPI spec, use [Get OpenAPI
    spec](https://launchdarkly.com/docs/api/other/get-openapi-spec).
  contact:
    name: LaunchDarkly Technical Support Team
    url: https://support.launchdarkly.com
    email: support@launchdarkly.com
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0
  version: '2.0'
servers:
  - url: https://app.launchdarkly.com
    description: ' Default'
  - url: https://app.launchdarkly.us
    description: ' Federal'
security:
  - ApiKey:
      - read
      - write
tags:
  - name: Access tokens
    description: >-
      The access tokens API allows you to list, create, modify, and delete
      access tokens programmatically.
  - name: Account members
    description: >-
      The account members API allows you to invite new members to an account by
      making a `POST` request to `/api/v2/members`. When you invite a new member
      to an account, an invitation is sent to the email you provided.
  - name: Account usage (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: AI Configs
    description: >-
      The AI Configs API allows you to create, retrieve, and edit AI Configs, AI
      Config variations, and AI model configurations.
  - name: Announcements
    description: >-
      The announcements API lets you create and update a custom announcement
      banner that appears in the LaunchDarkly user interface for everyone in
      your organization.
  - name: Applications (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Approvals
    description: >-
      An account member can request approval on changes to a flag or AI Config's
      targeting or variations, or to a segment's targeting. Members may be
      required to request approval depending on the settings in their
      LaunchDarkly project.
  - name: Approvals (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Audit log
    description: >-
      LaunchDarkly maintains a record of all the changes made to any resource in
      the system. You can access this history using the audit log API, including
      filtering by timestamps, or using a custom policy to select which entries
      to receive.
  - name: Code references
    description: >-
      > ### Code references is an Enterprise feature > > Code references is
      available to customers on an Enterprise plan. To learn more, [read about
      our pricing](https://launchdarkly.com/pricing/).
  - name: Context settings
    description: >-
      You can use the context settings API to assign a context to a specific
      variation for any feature flag. To learn more, read [View and manage
      contexts](https://launchdarkly.com/docs/home/observability/context-attributes#view-and-manage-contexts).
  - name: Contexts
    description: >-
      Contexts are people, services, machines, or other resources that encounter
      feature flags in your product. Contexts are identified by their `kind`,
      which describes the type of resources encountering flags, and by their
      `key`.
  - name: Custom roles
    description: >-
      > ### Custom roles is an Enterprise feature > > Custom roles is available
      to customers on an Enterprise plan. To learn more, [read about our
      pricing](https://launchdarkly.com/pricing/).
  - name: Data Export destinations
    description: >-
      > ### Data Export is an add-on feature > > Data Export is available as an
      add-on for customers on a Foundation or Enterprise plan. To learn more,
      [read about our pricing](https://launchdarkly.com/pricing/).
  - name: Environments
    description: >-
      Environments allow you to maintain separate rollout rules in different
      contexts, from local development to QA, staging, and production. With the
      LaunchDarkly Environments API, you can programmatically list, create, and
      manage environments.
  - name: Experiments
    description: >-
      > ### Available for subscription customers > > Experimentation is
      available to all customers on a Developer, Foundation, or Enterprise
      subscription. If you're on an older Pro or Enterprise plan,
      Experimentation is available as an add-on.
  - name: Feature flags
    description: >-
      The feature flags API allows you to list, create, and modify feature flags
      and their targeting. For example, you can control percentage rollouts,
      target specific contexts, or even toggle off a feature flag
      programmatically.
  - name: Feature flags (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Flag import configurations (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Flag links (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Flag triggers
    description: >-
      > ### Flag triggers is an Enterprise feature > > Flag triggers is
      available to customers on an Enterprise plan. To learn more, [read about
      our pricing](https://launchdarkly.com/pricing/).
  - name: Follow flags
    description: >-
      Follow flags to receive email updates about targeting changes to a flag in
      a project and environment.
  - name: Holdouts (beta)
    description: >-
      > ### Available for customers using Experimentation > > Holdouts are
      available to customers using
      [Experimentation](https://launchdarkly.com/docs/api/experiments).
  - name: Insights charts (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Insights deployments (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Insights flag events (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Insights pull requests (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Insights repositories (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Insights scores (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Integration audit log subscriptions
    description: >-
      Audit log integration subscriptions allow you to send audit log events
      hooks to one of dozens of external tools. For example, you can send flag
      change event webhooks to external third party software.
  - name: Integration delivery configurations (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Integrations (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Layers
    description: >-
      > ### Available for customers using Experimentation > > Layers are
      available to customers using
      [Experimentation](https://launchdarkly.com/docs/api/experiments).
  - name: Metrics
    description: >-
      Metrics track flag behavior over time when an experiment is running. The
      data generated from experiments gives you more insight into the impact of
      a particular flag.
  - name: Metrics (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: OAuth2 Clients
    description: >-
      The OAuth2 client API allows you to register a LaunchDarkly OAuth client
      for use in your own custom integrations.
  - name: Persistent store integrations (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Projects
    description: >-
      Projects allow you to manage multiple different software projects under
      one LaunchDarkly account. Each project has its own unique set of
      environments and feature flags.
  - name: Relay Proxy configurations
    description: >-
      > ### Relay Proxy automatic configuration is an Enterprise feature > >
      Relay Proxy automatic configuration is available to customers on an
      Enterprise plan. To learn more, [read about our
      pricing](https://launchdarkly.com/pricing/).
  - name: Release pipelines (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Release policies (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Releases (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Scheduled changes
    description: >-
      > ### Scheduled flag changes is an Enterprise feature > > Scheduled flag
      changes is available to customers on an Enterprise plan. To learn more,
      [read about our pricing](https://launchdarkly.com/pricing/).
  - name: Segments
    description: >-
      > ### Synced segments and larger list-based segments are an Enterprise
      feature > > This section documents endpoints for rule-based, list-based,
      and synced segments.
  - name: Tags
    description: >-
      Tags are simple strings that you can attach to most resources in
      LaunchDarkly. Tags are useful for grouping resources into a set that you
      can name in a resource specifier.
  - name: Teams
    description: >-
      > ### Teams is an Enterprise feature > > Teams is available to customers
      on an Enterprise plan. To learn more, [read about our
      pricing](https://launchdarkly.com/pricing/).
  - name: Teams (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: User settings
    description: >-
      > ### Contexts are now available > > After you have upgraded your
      LaunchDarkly SDK to use contexts instead of users, you should use
      [Contexts](https://launchdarkly.com/docs/api/contexts) instead of the user
      settings API.
  - name: Users
    description: >-
      > ### Contexts are now available > > After you have upgraded your
      LaunchDarkly SDK to use contexts instead of users, you should use
      [Contexts](https://launchdarkly.com/docs/api/contexts) instead of these
      endpoints.
  - name: Users (beta)
    description: >-
      > ### Contexts are now available > > After you have upgraded your
      LaunchDarkly SDK to use contexts instead of users, you should use
      [Contexts](https://launchdarkly.com/docs/api/contexts) instead of these
      endpoints.
  - name: Views (beta)
    description: >-
      > ### This feature is in beta > > To use this feature, pass in a header
      including the `LD-API-Version` key with value set to `beta`. Use this
      header with each call.
  - name: Webhooks
    description: >-
      The webhooks API lets you build your own integrations that subscribe to
      activities in LaunchDarkly. When you generate an activity in LaunchDarkly,
      such as when you change a flag or you create a project, LaunchDarkly sends
      an HTTP POST payload to the...
  - name: Workflow templates
    description: >-
      > ### Workflows are in maintenance mode > > The workflows feature is in
      maintenance mode, and is planned for future deprecation at a date not yet
      specified.
  - name: Workflows
    description: >-
      > ### Workflows are in maintenance mode > > The workflows feature is in
      maintenance mode, and is planned for future deprecation at a date not yet
      specified.
  - name: Other
    description: Other requests available in the LaunchDarkly API.
paths:
  /api/v2/approval-requests/{id}/reviews:
    post:
      tags:
        - Approvals
      summary: Review approval request
      description: >-
        > For the complete documentation index, see
        [llms.txt](https://launchdarkly-preview.mintlify.app/llms.txt). For the
        full documentation snapshot, see
        [llms-full.txt](https://launchdarkly-preview.mintlify.app/llms-full.txt).


        Review an approval request by approving or denying changes.
      operationId: postApprovalRequestReview
      parameters:
        - name: id
          in: path
          description: The approval request ID
          required: true
          schema:
            type: string
            format: string
            description: The approval request ID
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/postApprovalRequestReviewRequest'
        required: true
      responses:
        '200':
          description: Approval request review response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApprovalRequestResponse'
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InvalidRequestErrorRep'
        '401':
          description: Invalid access token
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthorizedErrorRep'
        '404':
          description: Invalid resource identifier
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFoundErrorRep'
        '405':
          description: Method not allowed
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MethodNotAllowedErrorRep'
        '409':
          description: Status conflict
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/StatusConflictErrorRep'
        '429':
          description: Rate limited
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RateLimitedErrorRep'
components:
  schemas:
    postApprovalRequestReviewRequest:
      type: object
      properties:
        kind:
          type: string
          description: The type of review for this approval request
          example: approve
          enum:
            - approve
            - comment
            - decline
        comment:
          type: string
          description: Optional comment about the approval request
          example: Looks good, thanks for updating
    ApprovalRequestResponse:
      type: object
      required:
        - _id
        - _version
        - creationDate
        - serviceKind
        - reviewStatus
        - allReviews
        - notifyMemberIds
        - status
        - instructions
        - conflicts
        - _links
      properties:
        _id:
          type: string
          description: The ID of this approval request
          example: 12ab3c45de678910abc12345
        _version:
          type: integer
          description: Version of the approval request
          example: 1
        creationDate:
          $ref: '#/components/schemas/UnixMillis'
          description: Timestamp of when the approval request was created
          example: '1654104600000'
        serviceKind:
          $ref: '#/components/schemas/ApprovalRequestServiceKind'
          description: >-
            The approval service for this request. May be LaunchDarkly or an
            external approval service, such as ServiceNow or JIRA.
          example: launchdarkly
        requestorId:
          type: string
          description: The ID of the member who requested the approval
          example: 12ab3c45de678910abc12345
        description:
          type: string
          description: A human-friendly name for the approval request
          example: 'example: request approval from someone'
        reviewStatus:
          type: string
          description: Current status of the review of this approval request
          example: pending
          enum:
            - approved
            - declined
            - pending
        allReviews:
          type: array
          description: An array of individual reviews of this approval request
          items:
            $ref: '#/components/schemas/ReviewResponse'
        notifyMemberIds:
          type: array
          description: >-
            An array of member IDs. These members are notified to review the
            approval request.
          items:
            type: string
          example:
            - 1234a56b7c89d012345e678f
        appliedDate:
          $ref: '#/components/schemas/UnixMillis'
          description: Timestamp of when the approval request was applied
          example: '1654104600000'
        appliedByMemberId:
          type: string
          description: The member ID of the member who applied the approval request
          example: 1234a56b7c89d012345e678f
        appliedByServiceTokenId:
          type: string
          description: >-
            The service token ID of the service token which applied the approval
            request
          example: 1234a56b7c89d012345e678f
        status:
          type: string
          description: Current status of the approval request
          example: pending
          enum:
            - pending
            - completed
            - failed
            - scheduled
        instructions:
          $ref: '#/components/schemas/Instructions'
          description: >-
            List of instructions in semantic patch format to be applied to the
            feature flag
          example: '[{"kind": "turnFlagOn"}]'
        conflicts:
          type: array
          description: Details on any conflicting approval requests
          items:
            $ref: '#/components/schemas/Conflict'
        _links:
          type: object
          additionalProperties: {}
          description: The location and content type of related resources
        executionDate:
          $ref: '#/components/schemas/UnixMillis'
          description: Timestamp for when instructions will be executed
          example: '1654104600000'
        operatingOnId:
          type: string
          description: ID of scheduled change to edit or delete
          example: 12ab3c45de678910abc12345
        integrationMetadata:
          $ref: '#/components/schemas/IntegrationMetadata'
          description: >-
            Details about the object in an external service corresponding to
            this approval request, such as a ServiceNow change request or a JIRA
            ticket, if an external approval service is being used
        source:
          $ref: '#/components/schemas/CopiedFromEnv'
          description: Details about the source feature flag, if copied
        customWorkflowMetadata:
          $ref: '#/components/schemas/CustomWorkflowMeta'
          description: >-
            Details about the custom workflow, if this approval request is part
            of a custom workflow
        resourceId:
          type: string
          description: String representation of a resource
        approvalSettings:
          $ref: '#/components/schemas/ApprovalSettings'
          description: The settings for this approval
    InvalidRequestErrorRep:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: string
          description: Specific error code encountered
          example: invalid_request
        message:
          type: string
          description: Description of the error
          example: Invalid request body
    UnauthorizedErrorRep:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: string
          description: Specific error code encountered
          example: unauthorized
        message:
          type: string
          description: Description of the error
          example: Invalid access token
    NotFoundErrorRep:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: string
          description: Specific error code encountered
          example: not_found
        message:
          type: string
          description: Description of the error
          example: Invalid resource identifier
    MethodNotAllowedErrorRep:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: string
          description: Specific error code encountered
          example: method_not_allowed
        message:
          type: string
          description: Description of the error
          example: Method not allowed
    StatusConflictErrorRep:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: string
          description: Specific error code encountered
          example: optimistic_locking_error
        message:
          type: string
          description: Description of the error
          example: Conflict. Optimistic lock error. Try again later.
    RateLimitedErrorRep:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: string
          description: Specific error code encountered
          example: rate_limited
        message:
          type: string
          description: Description of the error
          example: You've exceeded the API rate limit. Try again later.
    UnixMillis:
      type: integer
      format: int64
    ApprovalRequestServiceKind:
      type: string
    ReviewResponse:
      type: object
      required:
        - _id
        - kind
      properties:
        _id:
          type: string
          description: The approval request ID
          example: 12ab3c45de678910abc12345
        kind:
          type: string
          description: The type of review action to take
          example: approve
          enum:
            - approve
            - decline
            - comment
        creationDate:
          $ref: '#/components/schemas/UnixMillis'
          description: Timestamp of when the request was created
          example: '1653606981113'
        comment:
          type: string
          description: A comment describing the approval response
          example: Approved!
        memberId:
          type: string
          description: ID of account member that reviewed request
          example: 12ab3c45de678910abc12345
        serviceTokenId:
          type: string
          description: ID of account service token that reviewed request
          example: 12ab3c45de678910abc12345
    Instructions:
      type: array
      items:
        $ref: '#/components/schemas/Instruction'
    Conflict:
      type: object
      properties:
        instruction:
          $ref: '#/components/schemas/Instruction'
          description: >-
            Instruction in semantic patch format to be applied to the feature
            flag
        reason:
          type: string
          description: Reason why the conflict exists
    IntegrationMetadata:
      type: object
      required:
        - externalId
        - externalStatus
        - externalUrl
        - lastChecked
      properties:
        externalId:
          type: string
        externalStatus:
          $ref: '#/components/schemas/IntegrationStatus'
        externalUrl:
          type: string
        lastChecked:
          $ref: '#/components/schemas/UnixMillis'
    CopiedFromEnv:
      type: object
      required:
        - key
      properties:
        key:
          type: string
          description: Key of feature flag copied
          example: source-flag-key-123abc
        version:
          type: integer
          description: Version of feature flag copied
          example: 1
    CustomWorkflowMeta:
      type: object
      properties:
        name:
          type: string
          description: The name of the workflow stage that required this approval request
          example: Example workflow name
        stage:
          $ref: '#/components/schemas/CustomWorkflowStageMeta'
          description: >-
            Details on the stage of the workflow where this approval request is
            required
    ApprovalSettings:
      type: object
      required:
        - required
        - bypassApprovalsForPendingChanges
        - minNumApprovals
        - canReviewOwnRequest
        - canApplyDeclinedChanges
        - serviceKind
        - serviceConfig
        - requiredApprovalTags
      properties:
        required:
          type: boolean
          description: If approvals are required for this environment
          example: true
        bypassApprovalsForPendingChanges:
          type: boolean
          description: Whether to skip approvals for pending changes
          example: false
        minNumApprovals:
          type: integer
          description: >-
            Sets the amount of approvals required before a member can apply a
            change. The minimum is one and the maximum is five.
          example: 1
        canReviewOwnRequest:
          type: boolean
          description: >-
            Allow someone who makes an approval request to apply their own
            change
          example: false
        canApplyDeclinedChanges:
          type: boolean
          description: >-
            Allow applying the change as long as at least one person has
            approved
          example: true
        autoApplyApprovedChanges:
          type: boolean
          description: >-
            Automatically apply changes that have been approved by all
            reviewers. This field is only applicable for approval services other
            than LaunchDarkly.
          example: true
        serviceKind:
          type: string
          description: Which service to use for managing approvals
          example: launchdarkly
        serviceConfig:
          type: object
          additionalProperties: {}
          example: {}
        requiredApprovalTags:
          type: array
          description: >-
            Require approval only on flags with the provided tags. Otherwise all
            flags will require approval.
          items:
            type: string
          example:
            - require-approval
        serviceKindConfigurationId:
          type: string
          description: >-
            Optional field for integration configuration ID of a custom approval
            integration. This is an Enterprise-only feature.
          example: 1ef45a85-218f-4428-a8b2-a97e5f56c258
    Instruction:
      type: object
      additionalProperties: {}
    IntegrationStatus:
      type: object
      required:
        - display
        - value
      properties:
        display:
          type: string
        value:
          type: string
    CustomWorkflowStageMeta:
      type: object
      properties:
        index:
          type: integer
          description: The zero-based index of the workflow stage
          example: 0
        name:
          type: string
          description: The name of the workflow stage
          example: Stage 1
  securitySchemes:
    ApiKey:
      type: apiKey
      in: header
      name: Authorization

````